package org.ts.ddcs.itemdatatemplate.sw;


import com.alibaba.fastjson.JSONObject;
import org.ts.ddcs.common.util.BytesHelp;
import org.ts.ddcs.common.util.Sw2014DatagramTemplateHelp;
import org.ts.ddcs.common.util.ValueLen;
import org.ts.ddcs.itemdatatemplate.DataItemTemplate;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * FF33
 * 流量计4，1小时内5分钟时段流量
 */
public class DataItemTemplateEXT_33 extends DataItemTemplate {


    @Override
    public int stream(byte[] data, int index) {
        this.macth = false;
        this.bigDecimalValues = new ArrayList<>();
        int count = 0;
        String flag = BytesHelp.byte2HexStr(data, index + count, 2);
        if (flag.toUpperCase().equals(this.feture)) {
            count += 2;
            ValueLen valueLen = Sw2014DatagramTemplateHelp.getValueLen(data, index + count);
            count += 1;
            //5字节一个值,4个小数位
            for (int i = 0; i < 12; i++) {
                this.readBigDecimalValue(data, index + count, 5, 4);
                count += 5;
            }
            this.macth = true;
            this.valueLen = valueLen;
        }
        return count;
    }

    @Override
    public int stream(byte[] data, int index, int batchSize) {
        return 0;
    }

    @Override
    public String getStringValue() {
        BigDecimal value = this.bigDecimalValues.get(0);
        return value.setScale(4, BigDecimal.ROUND_DOWN).toPlainString();
    }

    @Override
    public void saveValue(Map<String, List<Map<String,Object>>> keyStore) {
        this.saveBigDecimalValues(keyStore, 4);
    }
}
